<p>Kada govorimo o računalu i razumijevanju istoga, proučavanje možemo raditi na mnogim
   razinama. U nastavku su pobrojane neke od razina te kolegiji na kojima se iste obrađuju.</p>

<h2>Tjeranje računala da radi ono što želimo</h2>

<p>Da bismo računalo natjerali da radi ono što želimo, moramo ga programirati. Programiranje je postupak kojim razvijamo računalni program koji je procesor računala sposoban izvoditi.</p>

<p>Procesor računala je digitalni sekvencijski sklop koji izvodi strojne instrukcije. Strojne instrukcije dohvaćaju se iz memorije. Procesor uobičajeno poznaje i zna izvoditi instrukcije koje mu nalažu da dohvati podatak iz memorije i pohrani ga u neki od svojih registara, zatim instrukcije koje mu nalažu da podatak iz registara zapiše natrag u memoriju, zatim instrukcije koje mu nalažu da nad podatcima koje čuva u registrima obavi određenu aritmetičku ili logičku operaciju i rezultat pohrane ponovno u neki registar, zatim instrukcije koje mijenjaju adresu s koje će se dohvatiti sljedeća instrukcija (takozvane instrukcije skoka) i mnoge druge. Instrukcije mogu biti duljine jednog ili više okteta, a o kojoj se instrukciji radi, procesor doznaje analizirajući koji su bitovi postavljeni a koji nisu u dohvaćenim oktetima. Pogledajmo primjer.</p>

<p>Jednostavan model računala s kojim ćemo raditi kroz ovu seriju minilekcija sadrži procesor kod kojeg su instrukcije duljine jedan ili dva okteta (dakle 8 ili 16 bitova). Pri tome je vrstu instrukcije moguće odrediti iz prvog okteta, a drugi, ako postoji, sadrži dodatne informacije poput memorijske lokacije nad kojom instrukcija treba djelovati. Ako su prva četiri bita u oktetu postavljena na 0, radi se o instrukciji <code>MOV ra, rb</code> koja ima dva argumenta: <code>rb</code> je registar koji sadrži podatak a <code>ra</code> je registar u koji taj podatak treba prekopirati. Naš procesor raspolaže s četiri registra: <code>r0</code>, <code>r1</code>, <code>r2</code> i <code>r3</code>. O kojim se registrima radi, moguće je prepoznati iz preostala četiri bita; naime, struktura ove instrukcije je:</p>
<pre>0000aabb</pre>
<p>pri čemu, kako se radi o grupama od dva bita, <code>aa</code> i <code>bb</code> svaki mogu biti <code>00</code> ili <code>01</code> ili <code>10</code> ili <code>11</code>, čime određuju radi li se o registru <code>r0</code> ili <code>r1</code> ili <code>r2</code> ili <code>r3</code> (grupu bitova potrebno je protumačiti kao binarno zapisani cijeli broj - to je broj registra). Ostale instrukcije prepoznaju se po drugačijim kombinacijama bitova.</p>

<p>Čovjeku je pisanje programa na ovoj razini vrlo mukotrpno i sklono pogreškama. Stoga ljudi programiraju pišući programe uporabom programskih jezika.</p>

<p>Programski jezik najniže razine jest Assembler. Assembler za svaku od instrukcija definira njezino simboličko ime, pa programer instrukciju po instrukciju piše koristeći simbolička imena. Primjerice, program koji se sastoji od dvije instrukcije: prve koja sadržaj registra <code>r0</code> kopira u registar <code>r1</code> i druge koja podatak zapisan u <code>r1</code> inkrementira (uvećava za 1), u Assembleru bi izgledao ovako:</p>
<pre>MOV r1, r0
INC r1</pre>
<p>Ovako napisani program potom bi trebalo prevesti izravno u oktete strojnog koda za što postoje programski alati. Time bismo dobili sljedeća dva okteta (u binarnom zapisu): 00000100 i 10110100, odnosno pročitano u dekadskom zapisu: 4 i 180. Te bismo brojeve zapisali u memoriju računala i time definirali program koji bi računalo znalo izvesti.</p>

<div class="mlNote">
<p>Na predmetu <em>Arhitektura računala 1</em> učit ćete kako izgleda programski model procesora te kako kroz assembler pisati programe za isti, uključivo i način pisanja potprograma, njihova pozivanja i povratka, prijenosa parametara putem stoga i slično.</p>
</div> 

<p>Programiranje računala na razini strojnih instrukcija vrlo je neproduktivno: čovjeku je potrebno puno vremena da napiše čak i najjednostavnije programe. Stoga su nastali programski jezici više razine. Jedan od takvih programskih jezika jest C. Evo primjera programa u njemu.</p>

<pre><code>
int main() {
  unsigned char a = 7;
  unsigned char b = a;
  b = b+1;
}</code></pre>

<p>Koristeći ovakav programski jezik, programeru je puno jednostavnije pisati programe, definirati različite strukture podataka, program razlagati u pomoćne funkcije te koristiti mnoge konstrukte za kontrolu toka izvođenja, poput naredbi grananja <code>if</code>-<code>else</code> i <code>switch</code>, petlji <code>for</code>, <code>while</code>, <code>do</code>,
preskakanje ostatka trenutne iteracije petlje (<code>continue</code>), prekidanje petlje (<code>break</code>) i slično. Programiranjem na ovoj razini, programer može biti učinkovitiji. Međutim, nerazumijevanje arhitekture stroja i činjenice da se napisani program izvodi na računalu s procesorom koji ima određene karakteristike, moguće je generirati vrlo neučinkovite programe. Stoga kvalitetni programeri vladaju programskim jezikom koji koriste ali istovremeno imaju i duboko razumijevanje stroja na kojem se program koji pišu treba izvoditi.</p>

<div class="mlNote">
<p>Na predmetu <em>Programiranje i programsko inženjerstvo</em> učit ćete pisati programe u programskom jeziku C. Učit ćete o varijablama i tipovima podataka, osnovnim konstruktima jezika, načinu pisanja i pozivanja funkcija, uporabi polja i slično.</p>
<p>Na predmetu <em>Algoritmi i strukture podataka</em> proširit ćete ovo znanje učenjem niza elementarnih algoritama koji se uobičajeno koriste u programima (poput postupaka sortiranja). Također, učit ćete o osnovnim strukturama podataka: ulančanim listama, redovima, stogovima, gomilama te stablima. Poznavanje ovih struktura kao i složenosti izvođenja operacijama nad njima (dodavanje elemenata po različitim kriterijima, pretraživanje, izmjena, brisanje) omogućit će Vam da pišete učinkovitije programe.</p>
<p>Na predmetu <em>Objektno orijentirano programiranje</em> imat ćete priliku naučiti kako Vam moderniji mehanizmi i koncepti poput polimorfnog pozivanja funkcija, enkapsulacije podataka, nasljeđivanja te zaštite pristupa mogu pomoći da pišete kvalitetnije programe.</p>
<p>Na predmetu <em>Oblikovni obrasci u programiranju</em> imat ćete priliku naučiti što je to što jedan program čini kvalitetnim; koje karakteristike želimo postići i kako to činimo, oslanjajući se na dobro poznata i provjerena rješenja.</p>
</div> 

<p>No, u svijetu računala, ovo je samo jedan od smjerova: krenuli smo od strojnog koda i došli do objektne paradigme i kvalitete programa. Svaki puta kada za programiranje koristimo bilo kakav programski jezik, moramo biti svjesni da je to nešto što procesor računala ne razumije. Stoga nam je potreban je programski sustav koji će kao ulaz znati primiti specifikaciju programa koju smo napisali u programskom jeziku, i koji će na temelju nje znati izgenerirati sve potrebne strojne instrukcije - na razini bitova - koje će osigurati da program radi ono što smo zamislili. Takvi se programski sustavi nazivaju prevodioci (engl. <i>compilers</i>).</p>

<div class="mlNote">
<p>Kako radi jedan prevodioc (i kako ga sami možete napisati), imat ćete priliku naučiti na kolegiju <em>Prevođenje programskih jezika</em>. Tu ćete učiti o leksičkoj, sintaksnoj i semantičkoj analizi, o generiraju koda i gramatikama.</p>
<p>Potrebna znanja na koja se oslanja spomenuti predmet steći ćete na kolegiju <em>Uvod u teoriju računarstva</em> gdje ćete, između ostaloga, detaljno učiti o determinističkim i nedeterminističkim automatima i njihovim podvrstama, o potisnim automatima i mnogim drugim konceptima.</p>
</div> 

<p>Prethodna priča od ideje računalnog sustava otišla je prema programskoj potpori (engl. <i>software</i>) i izradi iste. Drugi lanac predmeta ide detaljnije u pitanja sklopovlja. Naime, temeljno pitanje koje si možemo postaviti jest: kako je procesor izgrađen? Je li način njegove izgradnje samo jedan, ili možemo imati različite pristupe? Što nam sve sklopovlje nudi, a da se na to možemo osloniti pri pisanju programa? Prisjetite se samo informacija do kojih ste i sami vjerojatno došli: postoje "klasični" procesori, pa višejezgreni procesori, pa se spominje Hyper-threading, pa priručne memorije (engl. <i>Caches</i>), pa grafički procesori. A vjerojatno ste čuli i za kratice RISC i CISC.</p>

<div class="mlNote">
<p>Na kolegiju <em>Arhitektura računala 2</em> upoznat ćete se s načinom izgradnje procesora: sklopovskom upravljačkom jedinicom te mikroprogramiranom upravljačkom jedinicom. Razmatrat ćete i niz drugih pitanja te naučiti zašto je, primjerice, važno, ako pišete program koji množi dvije matrice, obilazak raditi po redcima a ne po stupcima. U bilo kojem programskom jeziku, ovu odluku definirate redoslijedom dviju petlji i na toj razini program, u funkcijskom smislu, neovisno o njihovom redoslijedu obavlja isti posao. No vrijeme potrebno za obavljanje tog zadatka itekako će ovisiti o njihovu redoslijedu. Razumijevanje građe procesora i njegova rada pomoći će Vam da pišete učinkovitije programe.</p>
</div> 

<p>Pitanje koje smo ostavili za kraj je sljedeće: <em>od čega</em> je izgrađen procesor?</p>

<div class="mlNote">
<p>Odgovor na pitanje: od čega je izgrađen procesor naučit ćete na kolegiju <em>Digitalna logika</em>. Na tom kolegiju razmatramo sva relevantna pitanja, poput brojevnih sustava, interpretacije niza bitova, kodiranja i zaštitnih kodiranja, Booleove algebre, osnovnih logičkih sklopova i njihove elektroničke implementacije, kombinacijskih modula, bistabila i sekvencijskih modula (poput brojila i registara), aritmetičkih sklopova, digitalno/analognih i analogno/digitalnih pretvornika, programirljivih modula te vrsta i implementacija memorijskih modula.</p>
<p>Kroz ovu seriju minilekcija dobit ćete uvid gdje se i kako te komponente koriste za izgradnju jednog procesora odnosno računalnog sustava. A proučavanje tih komponenata u širem kontekstu strukture jednog računalnog sustava odnosno procesora pomoći će Vam da kvalitetnije usvojite njihovu funkciju, shvatite princip njihova rada i pripremite se za kolegije koji dalje grade nad ovim gradivom.</p>
<p>Koji su fizikalni principi rada poluvodičkih elemenata od kojih gradimo osnovne logičke sklopove, moći ćete naučiti na kolegiju <em>Elektronika 1</em>.</p>
</div>

<p>Uz spomenute kolegije, mnoga povezana znanja imat ćete prilike steći kroz niz drugih kolegija, no njihovo pobrajanje i opis nadilazi ovu uvodnu minilekciju. Više informacija o njima dobit ćete tijekom studija, a možete se i samostalno raspitati.</p>
